
simulide 0.5.16

Changes:
  RC1:
    - Debugger updated to new simulation engine.
    - Remove libglibc dependency in Windows build (by acebrian).
    
  RC3:
    - Arduinos to Subcircuits.
    - Slew rate deactivated.
    - "About SimulIDE" dialog updated.
    
  RC4:
    - New MCUs properties updated to new dialog.
    - Create Base class for old and new MCUs.
    - MCUs: move pin management to eSource.
    - Clean debug msgs to stdout.
    - RamTable: scale sizes to font scale.
    - SubPackage: Allow unselect Main Component.
    - Set "Fusion" as default style.
  
  RC5:
    - Logic Components complete refactoring.
    
  RC6:
    - New MCUs: Interrupt raise from signal/slot to direct call.
    
  RC7:
    - Compiler: set working directory to source file.
    - New MCUs: load firmware default dir to circuit file.
    - NEW MCUs: STATUS from vector to bitwise.
    - McuCreator change Interrupt ceation.
    - New MCUs: regSignal optimization.
    - Component: setValue does not change units.
    
  RC8:
    - Completely remove SimAvr (now only New AVRs available).
    - Circuit ToolBar: Move settings menu to left side.
    - Use new extension for circuit files ".sim5".
    
New Features:
  RC1:
    - Dutch translation by mvandorp.
    - New Dialogs for Component properties.
    - New dialog for Editor/Compiler properties.
    - Frequency property for I2C Devices.
    - Increase Frequency meter resolution to 5 digits.
    - SSD1306 I2C Address property.
    - Logic Components Slew Rate.
    - Memory Viewer for RAM/ROM, I2C RAM/ROM and MCU EEPROM.
    - Speed up recompilations with Arduino (by acebrian).
    - MCU crash Warning message and animation.
    - Editable compilers first steps (gcbasic and avra).
    - Load and Save to file for Function Component.
    - Oscope V3.
    - I2C to Parallel: read implemented.
    
  RC2:
    - Debug Panel.
    - Colorize Logic Input/Output state.
    - Binary Couter: add Set Pin.
    - Resizable Multiplexer and Demultiplexer
    - Czech translation and help files.
    
  RC3:
    - Oscope & Analizer extended time frame.
    - MCU Monitor.
    - Open Component Properties at Double-Click.
    - Arduino Shields (experimental).
    - Memtable: accept decimal, octal or hexadecimal values.
    - Turkish translation (by Aejwt).
    
  RC4:
    - New AVRs: added 16 bit Timer base and Timer1.
    - New AVRs: Usart basic implementation (kindof working).
    - New MCUs: McuMonitor basic implementation.
    
  RC5:
    - Animate Inputs/Outputs as arrows.
    - McuMonitor: Sort Register list.
    - New Avrs: ADC.
    - New TWI Module.
    - New AVRs: TWI master read/write implemented.
    - New SPI Module.
    - New AVRs: SPI basic implementation.
    - Logic Analizer: change Time Pos by mouse click+move.
    - Logic Analizer: Condition Trigger.
    
  RC6:
    - Subcircuit: Name label editable.
    - AVR SPI: Basic case working.
    - New MCUs: Watchdog Timer basic implementation.
    - New AVRs: Watchdog Timer.
    - New MCUs: Reload and Autoload added.
    - New MCUs: Status & Registers added to Mcu Monitor.
    
  RC7:
    - New MCUs: EEPROM added.
    - New AVRs: EEPROM Working.
    - New MCUs: Usart Monitor added.
    - New AVRs: Analog Comparator basic implementation.
    - New AVRs: ADC triggers implemented (T1 capt. & Comp. still pending).
    - Component properties: Warning if property not valid.
    - OpAmp: Power Pins labels.
    - OpAmp: Switch Power Pins property.
    - Editor: multiline comment added to sintax files.
    - Editor: GcBasic sintax updated to match GCB IDE.
    - Warning Message after crash: save backup file.
  
  RC8:
    - New MCUs: Integrate with Editor/Compiler/debugger.
    - Meters: Switch Pins property.
    - Portuguese translation added.
    - Mono font embeded (keeps consistency across systems).
    - McuMonitor: Change font size and color & PC-STATUS position.
    - McuMonitor: Unify "Variables" & "RAM" tabs
    - McuMonitor: PC & flash by PGM word size or byte.
    - McuMonitor: Added "Jump to address" option.
    - MemTable: show ASCII by byte (2 for 16 bits and so on).
    - Editor/Debugger: "clear All Breakpoints" action added.
    - Editor/Compiler: Added "compile for debug" option.
    
Bug Fixes:
  RC1:
    - Error in 8051 Component name in mcs-51_test.simu.
    - Crash on new_mcu mega48,88,168. 
    - Oscope: printing wave out of display with only 1 channel connected.
    - Oscope: Pause on condition not working (RC4).
    - AVR I2C not working after circuit restart.
    - AVR: I2C module interfering pullups.
    - I2C Module randomly not working.
    - AudioOut: Crash when no audio output device found (by acebrian).
    - KY023: Button not working (by acebrian).
    - Arduino compiler can't find includes.
    - Audio Output cracking souds.
    - Ampmeter & Voltmeter wrong decimals.
    - Crash with new subcircuits connected to buses.
    - Circuit not animating wires in some cases.
    - MCU with Autoload activated brokens simulation.
    - Issues with Arduino debugger under Windows (by acebrian).
    - AVR "bricks" after avrcpu crash.
    - PIC MCUs not recovering from MCLR.
    - MCU logic symbol not working.
    - Hd44780 Error on command = 0.
    - Many subcircuit errors (by Sergey Roenko).
    - Crash connecting/disconnecting to switch, 7Segment, Ledmatrix.
    - AVR can miss port states in some cases.
    - Crash setting Keypad rows or cols to 0.
    - Some Pic Package errors.
    - Redraw trazes in inverted Pins, SevenSegment and SwitchDip.
    - AVR Aref Pin not working.
    - Tunnel not working if name is assigned after connection.
    - Frequencimeter not detecting low freqs.
    
  RC2:
    - Buffer: missing "Tristate" property.
    - Several subcircuit fixed (sergey Roenko).
    - Frequencimeter not updating after wave is lost.
    - Component Properties dialog can't be closed in Windows version.
    - Logic Components: rewrite slew rate simulation.
    - AVR Timer1 not working in CTC OCRA mode (4).
    - Error in Bjt.
    - Oscope initialization issues.
    - Oscope: ensure compatibility with old timeDiv.
    - Clock and WaveGen not saving On/Off state properly.
    - Problems in Windows build (by acebrian).
    - Arduino not showing variables in RamTable.
    - Package asking to be saved when it's unmodified.
    - Fixed Volt. not saving state properly.
    - Compatibility of some properties with older versions.
    - DC Motor problems.
    - AVR SPI not working.
    - Circuit: Copy/Paste missing connectors.
    - New MCus crash at creation.
    - Simulator: error in event counter.
    - Memtable: error representing negative values.
    - Chip: show Id property overriden at initChip.
    - Latch D: Size error when no OE and no Tristate.
    
  RC3:
    - Several Oscope issues.
    - FlipFlop not shown in non english languages.
    - Subcircuits not saving Main Component properties.
    - Subcircuit label wrong pos in old circuits.
    - Pic12F683 CCP1If flag not set.
    - Wrong Build date in About Widget.
    - Switches:label not hidden in Subcircuits.
    - PIC: Crash creating Mclr Pin.
    - Errors in some PIC packages.
    - MCU EEPROM: First value = 0.
    - PIC16F887 ADC Channel 7 not working.
    - Serial Monitor not working in new Arduinos.
    - All Variable Resistors: Errors in value multipliers.
    - Subcircuits not working after pasting.
    - Subcircuits fixed (sergey Roenko):
      7445, 74137, 74138, 74139, 74141,
      74145, 75154, 744028, 744514, 744515
      
  RC4:
     - Boards: error in some Pin angles.
    - Logic Analizer: wrong defaul Volt. Div.
    - Logic Analizer: set default Time Div to 1 ms.
    - 7 Seg BCD not working in Subcircuits.
    - Boards(Subcircuits): Childs moving if selected.
    - Fixed Volt: Error setting output voltage.
    - OutPanelText: Crash if Simulator does not exist.
    - Package errors: 74377, 74373, 74688
    - Tunnels: several errors.
    - Shields: several errors, icons.
    - Memory table: Crash clicking on column 16.
    - Fixed Volt, WaveGen, Clock: wrong output impedance.
    - Op Amp: new Output Impedance property (default to zero).
    - Crash in some systems due to MessageHandler.
    - Variable Resistors: error setting value from properties.
    - New MCU Timers: Error if counter > top.
    - New AVR: Reset Oc Pin at OcUnit enable.
    - New AVRs: PWM Phase Correct wrong freq.
    - New Arduinos: Crash opening Serial Monitor.
    - New AVRs: avoid pulses when Compare match = timer overflow.
    - New AVRs: address error setting extended I/O Regs.
    - Editor/Compiler: makefiles not working.
    - PIC Crash using Usart.
    - PIC: Crash in devices with no EEPROM.
    - Mosfet: error in some cases.
    - MCUs: dedicated Reset Pin not working.
    - AVR gdb not initialized.
    - Oscope not showing DC.
    - Oscope & LA: pulses not shown when subsample is active.
    - Oscope & LA: Connect to Tunnel not working
    - Oscope: Missing graphic if no wave detected.
    - Oscope: Error changing Time Div in box.
    - Oscope not working at long Time Div.
    - Oscope: fix square wave at low freq & long Time Div.
    - Oscope: default Time Div to 1 ms
    - Shields: Fix Context Menu.
    - AVR Timer: Error writting OCRA, wrong next compare match.
    - McuMonitor: Flash table to 16 bit.
    - McuMonitor: PC & Status only updated if tab0 selected.
    - Memory Table: wrong Address column size for memories > 256.
    - Crash resizing Memory after opening MemTable.
    - Tunnels & SubPackage should not be Main Component is Subcircuits.
      
  RC5:
    - 7Segment BCD not initialized.
    - All Message Boxes to non-blocking.
    - Audio Out not working.
    - AVR ADC wrong AVcc.
    - New MCUs: Crash deleting Mcu Monitor.
    - New MCUs: several errors.
    - MCU: Load EEPROM data not working.
    - New MCUs: several errors inTimers.
    - Oscope stops working after some time.
    
  RC6:
    - Buses not working if Pins share eNode.
    - Editor/Compiler: no Error msg if upload not successful.
    - Arduino compiler: some errors not detected.
    - Arduino compiler: Errors with some file paths.
    - New AVRs: I2C Slave pulls SDA/SCL LOW.
    - New AVRs: Errors in TWI Slave.
    - New AVRs: TWI not saving received byte.
    - New AVRs: TWI Clock period not initialized.
    - TWI Module: Frequency doubles at reinitialization.
    - TWI Module: Slave not ACKing data received.
    - New AVRs: Wrong Stop Condition at I2C init.
    - TWI Module: I2C works even without pullups
    - New AVRs: Pullups not working.
    - SPI Module: wrong clock polarity in Windows version.
    - New AVRs: Pin Change Interrupt not working.
    - New AVRs: Pullups not working if no Port change.
    - New AVRs: Mcu Monitor Status bits wrong order.
    - Typos in some Example files.
    - Crash at Ananlog Multiplexer creation (random).
    - MCUs: msg NB Dialog: proccessor can not be created & delete component.
    - Errors in some AVR Packages.
    - New AVRs: ADC randomly not working.
    - OpAmp: Wrong Power Pin names (not working in subcircuits).
    - Function: wrong Pin positions.
    - Crash: Memory component running simulation.
    
  RC7:
    - Keypad not working.
    - New AVRs: Usart not taking control of I/O Pins.
    - New MCUs Usart: Error in first byte.
    - Error removing selected Components.
    - Old MCUs: pullup not working.
    - I2C Ram not working.
    - AVR TWI: Wrong Slave mode in some cases.
    - RAM/ROM not working.
    - Errors in Diode.
    - 74HC164 not working.
    - Latch: Invert Outputs property error.
    - New AVRs: EEPROM Working.
    - L298P not working.
    - Simulator Properties: Speed% spinbox decimal as dot.
    - Component Properties Dialog: missing properties.
    - New AVRs Timers not working properly after Rev 376.
    - New AVRs: PWM CTC OCA channel not working.
    - New MCUs: AutoLoad firmware stops simulation.
    - Avrs: Can't find hex file with non-latin characters in path.
    - Current Source: "Current" Prop. from Olver versions not loading.
    - Meters: Output pin not working.
    - Variable Resistors Properties: several issues.
    - Monospace font not working in MacOs version.
    
  RC8:
    - New MCUs: Serial Monitor not closing at MCU delete.
    - Arduinos & Shields: set Transforming origin to center.
    - Potentiometer not loading value correctly.
    - New MCUs: Usart not working.
    - New MCUs: Modules not properly deleted.
    - Arduino custom board: don't include default context.
    - MCUs (old & new): McuMonitor not saving variable list.
    - New MCUs: eeprom not saved to .simu file.
    - HD44780 LCD: Error in cursor position, Blink color and speed.
    - Arduino Compiler: add quotes to paths in Linux version as well.
    - Decoder (4 to 10/16): Output0 keeps on.
    - RAM/ROM not working.
    - Function Component: Error using Analog Output.
    - New MCUs: Serial Monitor several problems.
    - New AVRs: Several errors in PWM.
    - New MCUs: Mcu Monitor not finding variables.
    - New AVRs: ADC left adjust not working.
    - Logic Components not hidding Pins in Boards.
    - New MCUs: device label not visible.
    - SubPackage::remove() not removing Poperties Dialog.
    - Crash deleting Subcircuits if selected in a group.
    - Code Editor: Error in properties dialog.
    - Arduino Compiler: override Board in file.
    - Bus: startBit not Initialized.
    - New MCUs: Solve permanent Input or Output issue.
    - Arduino Compiler: missing data types & multiple declaration.
    - New AVRs: Errors in WDT.
    - New AVRs: Error in ADC autotrigger.
    - New MCUs: Pins animation not updating.
    - New MCUs: Port Input Register not updated if Pin is not connected.
    - RAM/ROM: not reading/writting at address pins change.
    - Editor/Debugger: Keep breakpoints, don't force bebug line visible.
    - SubPackage: Errors moving Pins.
    - WS2812 Led: chaining leds not working.
    - Subcircuit categories not working in translations.
    - Missing avra includes.
    - Opening Circuits with Arduinos not centered in view.
    
New Components:
  RC1:
    - aip31068 I2C LCD (by acebrian).
    - Max72xx Led matrix (by acebrian).
    - 74XX189.
    - "Scripted" component (basic implementation).
    - Subcircuits (by Sergey Roenko):
        tpic6a595,
        K176IE3, K176IE4, K176IE5, K176IE12,
        74HC640, 74HC643, 74HC645,

  RC2:
    - FlipFlop RS.
    - Logic Analizer basic implementation.
    - New Subcircuits (sergey Roenko): 
      7489, 74200, 74219, 74301.
      
  RC3:
    - atmega8515 (by avklab)
    
    - New Subcircuits (sergey Roenko): 
        7497, 74184, 74185, 74502, 74503, 
        CD4054, CD4055, CD4056,
        K155ID11, K155ID13, 564Ik2
        L298, ULN2001, ULN2803
    
  RC4:
    - "Tools" Boards (by Sergey Roenko).

  RC5:
    - Subcircuits (by Sergey Roenko).
        74XX121, CD4098, K490IP1, K490Ip2
        AM1402ttl, AM1403ttl, AM1404_ttl.

  RC6:
    - Subcircuits (by Sergey Roenko):
        AD7224, AD7520, AD7521, AD7524, AD7845,
        DAC7621, DAC8562, 74HC139.
